/* 
**(c) Copyright 1989,1990,1991 Novell Inc. All Rights Reserved. 
*/

/*
 *  (C) Copyright 1989,90  Novell, Inc.  All rights reserved.
 *
 *  $Logfile:   P:/glblinc/vcs/btrieve.h_v  $
 *  $Revision:   2.0  $
 *  $Date:   07 Apr 1992 13:29:56  $
 *  $Author:   KLEUNG  $
 *  $Log:   P:/glblinc/vcs/btrieve.h_v  $
**  
**     Rev 2.0   07 Apr 1992 13:29:56   KLEUNG
**  Beginning of CS 1.3 changes
**  
**     Rev 1.16   15 Jan 1992 17:28:38   KLEUNG
**  Add function prototype for btrv.
**  
**     Rev 1.15   22 May 1991 11:18:30   ARAO
**  Added Copyright Notice
**  
**     Rev 1.14   17 Aug 1990 09:45:32   AVANWINK
**  Changed BTRIEVE_ERROR_READ_OUTSIDE_TRANS to BTRIEVE_ERROR_OUT_OF_TRANS
**  to shrink it by one character for no compiler warnings.
**
**     Rev 1.13   14 Aug 1990 10:36:28	 AVANWINK
**  Added new error defines:  07, 80, 82, 83, 85, 92, 98.
**
**     Rev 1.12   07 Jun 1990 17:12:34	 AVANWINK
**  Error define update.
**
**     Rev 1.11   07 Jun 1990 10:11:58	 AVANWINK
**  Added BTRIEVE_SUCCESS define.
**
**     Rev 1.10   07 Jun 1990 09:30:00	 AVANWINK
**  Added new btrieve error defines for transfer to DBA registered errors.
**
**     Rev 1.9	 03 May 1990 17:51:42	AVANWINK
**  Added external declaration to btrvID entry definition.
**
**     Rev 1.8	 03 May 1990 17:08:04	AVANWINK
**  Update to btrvID parameter list - changed btClientId *    to   void *  .C
**
**     Rev 1.7	 03 May 1990 15:30:20	AVANWINK
**  Adjustment to client ID structure.
**
**     Rev 1.6	 10 Apr 1990 17:48:06	AVANWINK
**  Added max key number.
**
**     Rev 1.5	 10 Apr 1990 17:38:00	AVANWINK
**  Added get extended definitions.
**
**     Rev 1.4	 28 Mar 1990 15:04:54	AVANWINK
**  Typo.
**
**     Rev 1.3	 28 Mar 1990 14:57:44	AVANWINK
**  Changed the clientId structure back to match the old now that
**  the object handle is kept in the first 12 bytes of the client ID.
**
**     Rev 1.2	 27 Mar 1990 14:08:18	AVANWINK
**  Added inclusion of CSTYPES.H at beginning of module.
**
**     Rev 1.1	 23 Mar 1990 15:10:36	AVANWINK
**  Changed the btrieve client ID structure for transaction support
**
**     Rev 1.0	 19 Mar 1990 16:02:26	VCS
**  Initial revision.
**
**     Rev 1.22   06 Mar 1990 17:52:28	 AVANWINK
**
**     Rev 1.21   27 Feb 1990 23:26:26	 AVANWINK
**  BT thread bug fix
**
**     Rev 1.20   19 Feb 1990 17:17:06	 AVANWINK
**  First pass with new tree support for open objects.
**
**     Rev 1.19   12 Feb 1990 18:55:08	 AVANWINK
**  Moved btrv() function definition from dbaapi.c
**
**     Rev 1.18   23 Jan 1990 18:46:36	 AVANWINK
**  Extended get change then change back.
**
**     Rev 1.17   17 Jan 1990 23:14:22	 AVANWINK
**  Added extended get receive structure.
**
**     Rev 1.16   16 Jan 1990 18:05:16	 AVANWINK
**  Added BTRIEVE_ERROR_END_OF_FILE and BTRIEVE_ERRROR_REJECT_COUNT_HIT
**
**     Rev 1.15   15 Jan 1990 14:58:12	 AVANWINK
**  Just before new register agent change final.
**
**     Rev 1.14   07 Jan 1990 18:33:42	 AVANWINK
**  Everything through read working.
**
**     Rev 1.13   02 Jan 1990 16:19:46	 AVANWINK
**  Create works
**
**     Rev 1.12   28 Dec 1989 18:44:00	 AVANWINK
**
**     Rev 1.11   21 Dec 1989 19:33:14	 AVANWINK
**
**     Rev 1.10   13 Dec 1989 18:07:06	 AVANWINK
**
**     Rev 1.9	 28 Nov 1989 18:00:26	AVANWINK
**
**     Rev 1.8	 22 Nov 1989 10:02:50	AVANWINK
**  No change.
**
**     Rev 1.7	 15 Nov 1989 17:56:12	AVANWINK
**
**     Rev 1.0	 13 Nov 1989 10:42:40	unknown
**  Initial revision.
**
**     Rev 1.0	 06 Nov 1989 14:14:42	unknown
**  Initial revision.
**
**     Rev 1.1	 06 Nov 1989 11:20:40	AVANWINK
**  PVCS test
**
**     Rev 1.0	 03 Nov 1989 15:46:06	AVANWINK
**  Initial revision.
**
**     Rev 1.0	 03 Nov 1989 14:33:44	BBOHDANO
**  Initial revision.
 */

#ifndef _CSTYPES_INCLUDED
#include "cstypes.h"
#endif

/*
 *
 *  Synchronize include environment:
 *
 *  o  Make sure file is not already included
 *  o  Define presence of this file
 *
 */
#ifndef _BT_INCLUDED
#define _BT_INCLUDED

/*
 *  Btrieve commands.
 */
#define 	BTRIEVE_CMD_OPEN			0
#define 	BTRIEVE_CMD_CLOSE			1
#define 	BTRIEVE_CMD_INSERT			2
#define 	BTRIEVE_CMD_UPDATE			3
#define 	BTRIEVE_CMD_DELETE			4
#define 	BTRIEVE_CMD_GET_EQU			5
#define 	BTRIEVE_CMD_GET_NEXT			6
#define 	BTRIEVE_CMD_GET_PREV			7
#define 	BTRIEVE_CMD_GET_GRTR			8
#define 	BTRIEVE_CMD_GET_GRTR_EQU		9
#define 	BTRIEVE_CMD_GET_LESS			10
#define 	BTRIEVE_CMD_GET_LESS_EQU		11
#define 	BTRIEVE_CMD_GET_FIRST			12
#define 	BTRIEVE_CMD_GET_LAST			13
#define 	BTRIEVE_CMD_CREATE			14
#define 	BTRIEVE_CMD_TRANS_BEGIN 		19
#define 	BTRIEVE_CMD_TRANS_END			20
#define 	BTRIEVE_CMD_TRANS_ABORT 		21
#define 	BTRIEVE_CMD_GET_NEXT_EXT		36
#define 	BTRIEVE_CMD_GET_PREV_EXT		37

#define 	BTRIEVE_CMD_GET_KEY			50

/*
 *  Btrieve file open modes.
 */
#define 	BTRIEVE_OPEN_NORMAL			0
#define 	BTRIEVE_OPEN_READ_ONLY		       -2
#define 	BTRIEVE_OPEN_EXCLUSIVE		       -4

/*
 *  Btrieve file create definitions.
 */
#define 	BTRIEVE_KEYS_MAX			24

#define 	BTRIEVE_CREATE_NORMAL			0
#define 	BTRIEVE_CREATE_WARN		       -1

#define 	BTRIEVE_FILE_VARIABLE_LENGTH		0x0001
#define 	BTRIEVE_FILE_BLANK_TRUNCATION		0x0002
#define 	BTRIEVE_FILE_PREALLOCATION		0x0004
#define 	BTRIEVE_FILE_DATA_COMPRESSION		0x0008
#define 	BTRIEVE_FILE_KEY_ONLY			0x0010
#define 	BTRIEVE_FILE_10_PERCENT_FREE		0x0040
#define 	BTRIEVE_FILE_20_PERCENT_FREE		0x0080
#define 	BTRIEVE_FILE_30_PERCENT_FREE		0x00C0

#define 	BTRIEVE_KEY_DUPLICATE			0x0001
#define 	BTRIEVE_KEY_MODIFIABLE			0x0002
#define 	BTRIEVE_KEY_BINARY			0x0004
#define 	BTRIEVE_KEY_NULL			0x0008
#define 	BTRIEVE_KEY_SEGMENTED			0x0010
#define 	BTRIEVE_KEY_ALT_COL_SEQ 		0x0020
#define 	BTRIEVE_KEY_DESCENDING			0x0040
#define 	BTRIEVE_KEY_SUPPLEMENTAL		0x0080
#define 	BTRIEVE_KEY_EXTENDED			0x0100

#define 	BTRIEVE_EXTENDED_STRING 		0x00
#define 	BTRIEVE_EXTENDED_INTEGER		0x01
#define 	BTRIEVE_EXTENDED_FLOAT			0x02
#define 	BTRIEVE_EXTENDED_DATE			0x03
#define 	BTRIEVE_EXTENDED_TIME			0x04
#define 	BTRIEVE_EXTENDED_DECIMAL		0x05
#define 	BTRIEVE_EXTENDED_MONEY			0x06
#define 	BTRIEVE_EXTENDED_LOGICAL		0x07
#define 	BTRIEVE_EXTENDED_NUMERIC		0x08
#define 	BTRIEVE_EXTENDED_BFLOAT 		0x09
#define 	BTRIEVE_EXTENDED_LSTRING		0x0A
#define 	BTRIEVE_EXTENDED_ZSTRING		0x0B
#define 	BTRIEVE_EXTENDED_UNS_BIN		0x0E
#define 	BTRIEVE_EXTENDED_AUTO_INC		0x0F


/*
 *  Btrieve get extended definitions.
 */
#define 	BTRIEVE_GET_EXT_COMP_EQU		1
#define 	BTRIEVE_GET_EXT_COMP_GRTR		2
#define 	BTRIEVE_GET_EXT_COMP_LESS		3
#define 	BTRIEVE_GET_EXT_COMP_NOT_EQU		4
#define 	BTRIEVE_GET_EXT_COMP_GRTR_EQU		5
#define 	BTRIEVE_GET_EXT_COMP_LESS_EQU		6

#define 	BTRIEVE_FILTER_LAST_TERM		0
#define 	BTRIEVE_FILTER_AND_TERMS		1
#define 	BTRIEVE_FILTER_OR_TERMS 		2


/*
 *  Btrieve return codes.
 */
#define 	BTRIEVE_SUCCESS 			0

#define 	BTRIEVE_ERROR_KEY_VALUE 		4
#define 	BTRIEVE_ERROR_DIFF_KEY_NUMBER		7
#define 	BTRIEVE_ERROR_POSITION			8
#define 	BTRIEVE_ERROR_END_OF_FILE		9
#define 	BTRIEVE_ERROR_FILENAME_INVALID		11
#define 	BTRIEVE_ERROR_FILE_NOT_FOUND		12
#define 	BTRIEVE_ERROR_PAGESIZE			24
#define 	BTRIEVE_ERROR_CREATE_IO 		25
#define 	BTRIEVE_ERROR_KEY_COUNT 		26
#define 	BTRIEVE_ERROR_KEY_POSITION		27
#define 	BTRIEVE_ERROR_RECORD_LENGTH		28
#define 	BTRIEVE_ERROR_KEY_LENGTH		29
#define 	BTRIEVE_ERROR_TRANS			36
#define 	BTRIEVE_ERROR_TRANS_ACTIVE		37
#define 	BTRIEVE_ERROR_TRANS_IO			38
#define 	BTRIEVE_ERROR_TRANS_END_ABORT		39
#define 	BTRIEVE_ERROR_TRANS_MAX_FILES		40
#define 	BTRIEVE_ERROR_ACCESS_DENIED		46
#define 	BTRIEVE_ERROR_KEY_TYPE			49
#define 	BTRIEVE_ERROR_FILE_EXISTS		59
#define 	BTRIEVE_ERROR_REJECT_COUNT_HIT		60
#define 	BTRIEVE_ERROR_DESCRIPTOR		62
#define 	BTRIEVE_STATUS_FILTER_LIMIT_HIT 	64
#define 	BTRIEVE_ERROR_CONFLICT			80
#define 	BTRIEVE_ERROR_LOST_POSITION		82
#define 	BTRIEVE_ERROR_READ_OUT_OF_TRANS 	83
#define 	BTRIEVE_ERROR_FILE_IN_USE		85
#define 	BTRIEVE_ERROR_TRANS_TABLE_FULL		92
#define 	BTRIEVE_ERROR_TRANS_INTERNAL		98


/*
 *  Btrieve file position block definition.
 */
typedef      u8_t	posBlk_t[128];



typedef struct	filterrepeat_t {

	     u8_t	fieldType;		/* Btrieve field data type  */
	    i16_t	fieldLen;		/* Filter field length	    */
	    i16_t	fieldOffset;		/* 0 relative field offset  */
	     u8_t	compareCode;		/* Filter compare code	    */
	     u8_t	filterLogic;		/* Filter logic expression  */
	     u8_t	compareField[1];	/* First byte of comp field */

} filterRepeat_t;



typedef struct	extractorrepeat_t {
						/*  extracted from record   */
	    i16_t	fieldLen;		/* Extracted field length   */
	    i16_t	fieldOffset;		/* 0 relative field offset  */

} extractorRepeat_t;


typedef struct	extractorspec_t {

	    i16_t	numRecsToExtract;	/* Number of records to get */
	    i16_t	numFieldsToExtract;	/* Number of fields	    */

} extractorSpec_t;


typedef struct	filterspec_t {

	    i16_t	descriptLen;		/* Total data buffer length */
	     i8_t	getConstant[2]; 	/* Extended get constant    */
	    i16_t	maxRecSkip;		/* Max records that can be  */
						/*  skipped while searching */
	    i16_t	numLogicTerms;		/* Number of logic terms in */
						/*  logic expresion (0 = no */
						/*  filtering performed     */
} filterSpec_t;


typedef struct	extgetrcvspec_t {

	    i16_t	numRecsReturned;

} extGetRcvSpec_t;


typedef struct {

	    u32_t	networkNumber;
	     u8_t	networkNode[6];
	     u8_t	socketNumber[2];
	     u8_t	uniqueId1[2];
	     u8_t	uniqueId2[2];

} btClientId_t;


/*
 *  Btrieve function definition.
 */
extern i16_t	btrvID(i16_t, void *, void *, void *, void *, i16_t, void *);
extern u16_t btrv(unsigned short, void *, void *, unsigned short *, void *, short);

#endif
