/*
 *  (C) Copyright 1989, 1990, 1991  Novell, Inc.  All rights reserved.
 *
 *   $Logfile:   P:/glblinc/vcs/cstypes.h_v  $
 *  $Revision:   2.5  $
 *      $Date:   16 Mar 1993 17:57:48  $
 *    $Author:   ROSEL  $
 *       $Log:   P:/glblinc/vcs/cstypes.h_v  $
**  
**     Rev 2.5   16 Mar 1993 17:57:48   ROSEL
**  Added MAX_CSNETID_SIZE to be used for CSNetID.
**  
**     Rev 2.4   29 May 1992 09:32:40   JSTABILE
**  Added definition for MAX_DGNGP_NAME_LEN
**  
**     Rev 2.3   29 May 1992 09:17:04   JSTABILE
**  Added definition for MAX_PRODUCT_ID_LEN
**  
**     Rev 2.2   21 May 1992 15:38:12   JSTABILE
**  Added definition for CS_ALL
**  
**     Rev 2.1   07 Apr 1992 17:28:10   RFROST
**  OS/2 changes
**
**     Rev 2.0   07 Apr 1992 13:29:16   KLEUNG
**  Beginning of CS 1.3 changes
**
**     Rev 1.10   30 Sep 1991 08:37:18   RSILVATI
**  General cleanup.
**
**     Rev 1.9   22 May 1991 11:16:40   ARAO
**  Added Copyright Notice
**
**     Rev 1.8   29 Aug 1990 09:21:46   AVANWINK
**  Added following defines so CSLIBI.H does not need to include DBREC.H:
**    MAX_MODEL_NUM_SIZ, MAX_IDENT_LOCATION_SIZ, MAX_IDENT_DESCRIPTION_SIZ,
**    MAX_IDENT_MISC_SIZ.
**
**     Rev 1.7   30 Jul 1990 16:04:58   MFROST
**  Added define of MAX_FILENAME_SIZE.
**
**     Rev 1.6   11 Jul 1990 16:09:58   COLSEN
**  Added serial number field size definition.
**
**     Rev 1.5   11 Jul 1990 15:57:46   AVANWINK
**  No change.
**
**     Rev 1.4   19 Mar 1990 17:11:52   AVANWINK
**  Added max bindery name size definition.
**
**     Rev 1.3   07 Feb 1990 10:07:58   AVANWINK
**  Added max size for host application ID field.
**
**     Rev 1.2  23 Jan 1990 14:09:10   AVANWINK
**  Added maximum protocal stack name size.
**
**     Rev 1.0  13 Nov 1989 10:42:42   unknown
**  Initial revision.
**
**     Rev 1.0  06 Nov 1989 14:14:46   unknown
**  Initial revision.
**
**     Rev 1.0  03 Nov 1989 17:44:52   unknown
**  Initial revision.
**
**     Rev 1.0  03 Nov 1989 17:05:34   unknown
**  Initial revision.
**
**     Rev 1.0  03 Nov 1989 17:03:42   unknown
**  Initial revision.
**
**     Rev 1.0  03 Nov 1989 16:58:38   unknown
**  Initial revision.
**
**     Rev 1.0  03 Nov 1989 15:28:34   AVANWINK
**  Initial revision.
**
**     Rev 1.0  03 Nov 1989 14:15:24   BBOHDANO
**  Initial revision.
 */

/*
 *  Synchronize include environment:
 *
 *  o  Make sure file is not already included
 *  o  Define presence of this file
 *
 */

#ifndef _CSTYPES_INCLUDED
#define _CSTYPES_INCLUDED


/*
 *  8-bit types
 */
typedef unsigned char               u8_t;
typedef unsigned char               U8_t;
typedef char                        i8_t;
typedef char                        I8_t;

/*
 *  16-bit types
 */
typedef unsigned short int          u16_t;
typedef unsigned short int          U16_t;
typedef short int                   i16_t;
typedef short int                   I16_t;

/*
 *  32-bit types
 */
typedef unsigned long int           u32_t;
typedef unsigned long int           U32_t;
typedef long int                    i32_t;
typedef long int                    I32_t;

typedef unsigned long               bool_t;  /* boolean variable           */
typedef unsigned long               BOOL_t;

/*
** the following section defines values used by all CS agents
*/
#define MAX_OBJ_NAME_SIZ            128      /* maximum length of a user name       */
#define MAX_BINDERY_NAME_SIZ        48       /* maximum length of name in bindery   */
#define MAX_PASSWD_SIZ              128      /* size of encrypted password          */
#define MAX_APP_NAME_SIZE           32       /* size of host application ID         */
#define MAX_SERIAL_NUM_SIZ          32       /* size of the serial no field         */

#define MAX_MODEL_NUM_SIZ           16       /* size of CS model no field           */
#define MAX_IDENT_LOCATION_SIZ      100      /* size of CS CFG location field       */
#define MAX_IDENT_DESCRIPTION_SIZ   300      /* size of CS CFG description field    */
#define MAX_IDENT_MISC_SIZ          400      /* size of CS CFG misc field           */

#define PROTOCOL_STACK_NAME_SIZ     16       /* Max size of ps name                 */
#define MAX_STRMDEV_NAME            32       /* max STREAMS device name length      */
#define MAX_STRMSET_NAME            128      /* max stream set name length          */
#define MAX_FILENAME_SIZE           255      /* max vol:\path\filename.ext          */
                                             /* including terminating NULL          */
                                             /* equivalent to FILENAME_MAX defined  */
                                             /* by including BOTH stdlib.h and      */
                                             /* stdio.h from clib                   */
#define NODE_ADDR_LEN               6        /* len of network node address buffer  */
#define CS_ALL                      ((u32_t)-1)  /* refers to all AgentIds */
#define MAX_PRODUCT_ID_LEN          9        /* size of product ID string */
#define MAX_DGNGP_NAME_LEN MAX_BINDERY_NAME_SIZ-MAX_PRODUCT_ID_LEN /* size of a dgngroup name */
#define MAX_CSNETID_SIZE            10       /* size of CSNetID; must be at least 10 */
                                             /* because we use it in IpxGetInternetAddress */

#ifndef OS2DEF_INCLUDED

#define NULL                        0        /* Nil pointer definition              */

#define FALSE                       0        /* variations of TRUE/FALSE            */
#define TRUE                        1
#define NO                          FALSE
#define YES                         TRUE

#endif	/* ifndef OS2DEF_INCLUDED */

#endif   /* _CSTYPES_INCLUDED */
