/*
**  (C) Copyright 1992 Novell, Inc.  All rights reserved.
**
**  File Name: nmvtdef.h
**
**  This file contains the structures and definitions required for
**  the Open Netview API.
**
**  $Logfile:   Q:/cs/nma/vcs/nmvtdef.h_v  $
**  $Revision:   1.5  $
**  $Date:   21 Sep 1992 16:07:08  $
**  $Author:   JCHOU  $
**  $Log:   Q:/cs/nma/vcs/nmvtdef.h_v  $
* 
*    Rev 1.5   21 Sep 1992 16:07:08   JCHOU
* Change the data vector type to start from 0. Always has to start from 0.
* 
*    Rev 1.4   13 Aug 1992 13:59:40   RWONG
* Remove obsolete vector types, input types.
* 
*    Rev 1.3   16 Jun 1992 13:42:42   JCHOU
* Added a data type for CAUSES
* 
*    Rev 1.2   29 Apr 1992 15:58:52   RWONG
* Add data types for predefined alert parameters.
** 
**     Rev 1.1   20 Apr 1992 14:45:00   RWONG
**  Make event types sequential (instead of bits).
** 
**     Rev 1.0   17 Apr 1992 14:07:42   RWONG
**  initial check in
**
*/
  
#ifndef _NMVTDEF_INCLUDED
#define _NMVTDEF_INCLUDED

/*
** Input Types - three types of alert format
*/
#define NVEVENT_NMVT               (0x01)   /* fully formatted NMVT */
#define NVEVENT_PREDEFINED         (0x02)   /* code point definition in DB */

/*
** These are the possible data vector types
*/                                  
/*
** Note: Care has to be taken to the following definition.
** Always assign the data type from 0 and do not forget
** to update the static definition of evtPtr in BuildNMVT
** routine.
*/
#define ARL_TYPE                   0
#define HRL_TYPE                   1
#define PARAMETER_LIST_TYPE        2
#define NMVT_TYPE                  3


#define APPLNAMESIZ                9
#define HRL_NAME_SZ                9
#define ARL_NAME_SZ                57
#define FILE_NAME_SZ               14
#define NUM_OF_DATA_VECTOR_TYPES   4

/*
** Display flag for Hierarchy Name List 0x10 subfield
*/
#define     DISPLAY_RESOURCE       0x00
#define     NO_DISPLAY_RESOURCE    0x40

/*
** Data types for predefined alert runtime parameters
*/
#ifndef _NMADEFS_INCLUDED  
#define     OCTETSTRING            0x04
#define     PRINTABLESTRING        0x13

#endif

#endif
