/*
**  (C) Copyright 1992 Novell, Inc.  All rights reserved.
**
**  File Name: nvipx.h
**
**  This file contains the message structure for sending alert NMVTs to
**  the Open NetView IPX socket-based API.
**
**  $Logfile:   G:/cs/nma/vcs/nvipx.h_v  $
**  $Revision:   1.0  $
**  $Date:   16 Oct 1992 09:24:32  $
**  $Author:   RWONG  $
**  $Log:   G:/cs/nma/vcs/nvipx.h_v  $
** 
**    Rev 1.0   16 Oct 1992 09:24:32   RWONG
** Initial revision.
*/
  
#ifndef _NVIPX_INCLUDED
#define _NVIPX_INCLUDED

#ifndef _CSPRIMS_INCLUDED
#include <csprims.h>
#endif

#ifndef _NMVTDEF_INCLUDED
#include <nmvtdef.h>
#endif

/*
** Send alert NMVTs to this socket on any NetWare for SAA or NMA for
** NetView server version 1.3 or above.
*/
#define NVSOCKET     0x907f

#define NM_EVENT_NOTIFICATION    (NMA_BASE + 0x0000000c)     
#define INTERNAL_SZ              78

typedef struct _nmvteventdata {
u8_t              DataType;     /* always NMVT_TYPE */
u8_t              Count;        /* always 1 */
u16_t             DataLen;      /* length of alert NMVT data */
u8_t              NMVTData[1];  /* first byte of alert NMVT data */
} NMVTEventData_t; 

typedef struct _nmvtevent {
u32_t             PrimType;     /* NM_EVENT_NOTIFICATION */
u32_t             ModuleId;     /* not used */
u32_t             RequestId;    /* not used */
u32_t             InputType;    /* NVEVENT_NMVT */
u32_t             reserved[2];  /* for future use */
u8_t              ServerName[ARL_NAME_SZ];   /* local file server name */
u8_t              internal[INTERNAL_SZ];     /* for internal use */
u8_t              EventDataCount;   /* always 1 */
NMVTEventData_t   EventData;    /* contains the alert NMVT */
} NMVTEvt_t;

#endif
